VBA code for changing reference when opening a . SLDPRT

Below the code, it must retrieve the 2 objects which are nevertheless well selected in solidworks!

Explicit Option

'Dim swApp As Object
Dim swApp As SldWorks.SldWorks
'Dim Part As Object
Dim Part As SldWorks.ModelDoc2

Dim Feature As Object
Dim vBody As Variant
Dim boolstatus As Boolean
Dim longstatus As Long
Dim longwarnings As Long
Dim FeatureName As String
Dim filename As String
Dim fileconfig As String
Dim filedispname As String
Dim fileoptions As Long
Dim Filter As String
Dim Piece As String
Dim swModExt As SldWorks.ModelDocExtension
Dim swBody As SldWorks.Body2
Dim sBodySelStr As String
Dim sBodyTypeSelStr As String
Sun i As Long
Dim bRet As Boolean
Dim result As String

Sub Combiner()
    'Set swApp = Application.SldWorks

'Recover the running SolidWorks instance
Set swApp = GetObject(, "SldWorks.Application")

'Allows you to view the SolidWorks application.
swApp.Visible = True
If swApp Is Nothing Then
Set swApp = CreateObject("SldWorks.Application")
swApp.Visible = True
End If
   
    MsgBox ("Main file selection!" & vbCrLf & "Main file selection!")

    Filter = "Solidworks Files (*.sldprt; *.sldasm)|*.sldprt;*.sldasm"
    Opens the parent file
    filename = swApp.GetOpenFilename("Selecting the parent file", "", Filter, fileoptions, fileconfig, filedispname)
   
    Set Part = swApp.OpenDoc6(filename, 1, 0, "", longstatus, longwarnings)
    Set Feature = Part.FirstFeature
   
    While Not Feature Is Nothing
        FeatureName = Feature.Name
        If Feature.GetTypeName2 = "Stock" Then
            Piece = FeatureName
        End If
        Set Feature = Feature.GetNextFeature()
    Wend
   
    'Deletes the "part body" file
    boolstatus = Part.Extension.SelectByID2(Piece, "BODYFEATURE", 0, 0, 0, False, 0, Nothing, 0)
    Part.EditDelete
   
    MsgBox ("Select Part to Subtract!" & vbCrLf & "Select Part to Subtract!")
   
    Opens the file to subtract
    filename = swApp.GetOpenFilename("Selecting the file to subtract", "", Filter, fileoptions, fileconfig, filedispname)
    Set Feature = Part.InsertPart2(filename, 15)
          
    vBody = Part.GetBodies2(swSolidBody, True)
    SelectBodies swApp, Part, vBody
               
    'Set Feature = Part.FeatureManager.InsertCombineFeature(swBodyOperationType_e.SWBODYCUT, Nothing, Nothing)
    Sun SelMgr As SelectionMgr
    Set SelMgr = Part.SelectionManager
    Set Feature = Part.FeatureManager.InsertCombineFeature(swBodyOperationType_e.SWBODYCUT, SelMgr.GetSelectedObject6(1, 1), SelMgr.GetSelectedObject6(1, 2))
   
End Sub

Sub SelectBodies(swApp As SldWorks.SldWorks, swModel As SldWorks.ModelDoc2, vBody As Variant)


    If IsEmpty(vBody) then Exit Sub
    Set swModExt = swModel.Extension
    For i = 0 TB UBound(vBody)
        Set swBody = vBody(i)
        sBodySelStr = swBody.GetSelectionId
        result = sBodySelStr
        If InStr(result, ">-<") Then
            bRet = swModExt.SelectByID2(result, "SOLIDBODY", 0#, 0#, 0#, True, 2, Nothing, 0)
        Else
            bRet = swModExt.SelectByID2(result, "SOLIDBODY", 0#, 0#, 0#, True, 1, Nothing, 0)
        End If
    Next i
       
End Sub

Hello

How do you launch your macro?

I took over your macro in its entirety and it works very well on my computer.

Kind regards

I run it from checkboxes in userforms, I also tried to run it live from the VBA editor, but still the same bug.

On the other hand, the one you sent executes perfectly.

Kind regards.

Check at all hazards if you don't have several Solidworks processes running. I can't reproduce the bug you have on 2 different PCs so it's hard to tell you where it could come from.

Hello

Wouldn't it be on "SelectBodies swApp, Part, vBody" that it crashes?

Debug step by step to see what's wrong.

This message appears when a function uses an object that is equal to nothing.

1 Like

Hello d.roger, Yves.T !

That's it, everything works!!

The bug came from the fact that there were unchecked Solidworks references in the VBA's tool option, which should therefore cause a communication problem with the software.

So I selected all the refs. Solidworks and I'll look later to determine which one was at fault. (I put you for information in attachments the refs that were missing)

Once again, a big thank you for the relevance of all your advice and support for the resolution of this problem, and d.roger continues to "tinker" in this way!! ☺


lyncoa_20171016.gif